# coding: utf-8

"""
    Deci Platform API

    Train, deploy, optimize and serve your models using Deci's platform, In your cloud or on premise.  # noqa: E501

    The version of the OpenAPI document: 4.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from deci_lab_client.configuration import Configuration


class GruRequestForm(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'target_hardwares': 'list[HardwareType]',
        'target_batch_sizes': 'list[int]',
        'target_metric': 'Metric',
        'optimize_model_size': 'bool',
        'quantization_levels': 'list[QuantizationLevel]',
        'optimize_autonac': 'bool',
        'name': 'str'
    }

    attribute_map = {
        'target_hardwares': 'targetHardwares',
        'target_batch_sizes': 'targetBatchSizes',
        'target_metric': 'targetMetric',
        'optimize_model_size': 'optimizeModelSize',
        'quantization_levels': 'quantizationLevels',
        'optimize_autonac': 'optimizeAutonac',
        'name': 'name'
    }

    def __init__(self, target_hardwares=["K80","V100","T4","Jetson Xavier","Jetson Nano","Jetson Xavier AGX","Cascade Lake","Skylake","Broadwell","Intel NUC Tiger Lake"], target_batch_sizes=[1], target_metric=None, optimize_model_size=False, quantization_levels=["FP16"], optimize_autonac=False, name=None, local_vars_configuration=None):  # noqa: E501
        """GruRequestForm - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._target_hardwares = None
        self._target_batch_sizes = None
        self._target_metric = None
        self._optimize_model_size = None
        self._quantization_levels = None
        self._optimize_autonac = None
        self._name = None
        self.discriminator = None

        if target_hardwares is not None:
            self.target_hardwares = target_hardwares
        if target_batch_sizes is not None:
            self.target_batch_sizes = target_batch_sizes
        if target_metric is not None:
            self.target_metric = target_metric
        if optimize_model_size is not None:
            self.optimize_model_size = optimize_model_size
        if quantization_levels is not None:
            self.quantization_levels = quantization_levels
        if optimize_autonac is not None:
            self.optimize_autonac = optimize_autonac
        if name is not None:
            self.name = name

    @property
    def target_hardwares(self):
        """Gets the target_hardwares of this GruRequestForm.  # noqa: E501


        :return: The target_hardwares of this GruRequestForm.  # noqa: E501
        :rtype: list[HardwareType]
        """
        return self._target_hardwares

    @target_hardwares.setter
    def target_hardwares(self, target_hardwares):
        """Sets the target_hardwares of this GruRequestForm.


        :param target_hardwares: The target_hardwares of this GruRequestForm.  # noqa: E501
        :type: list[HardwareType]
        """

        self._target_hardwares = target_hardwares

    @property
    def target_batch_sizes(self):
        """Gets the target_batch_sizes of this GruRequestForm.  # noqa: E501


        :return: The target_batch_sizes of this GruRequestForm.  # noqa: E501
        :rtype: list[int]
        """
        return self._target_batch_sizes

    @target_batch_sizes.setter
    def target_batch_sizes(self, target_batch_sizes):
        """Sets the target_batch_sizes of this GruRequestForm.


        :param target_batch_sizes: The target_batch_sizes of this GruRequestForm.  # noqa: E501
        :type: list[int]
        """

        self._target_batch_sizes = target_batch_sizes

    @property
    def target_metric(self):
        """Gets the target_metric of this GruRequestForm.  # noqa: E501


        :return: The target_metric of this GruRequestForm.  # noqa: E501
        :rtype: Metric
        """
        return self._target_metric

    @target_metric.setter
    def target_metric(self, target_metric):
        """Sets the target_metric of this GruRequestForm.


        :param target_metric: The target_metric of this GruRequestForm.  # noqa: E501
        :type: Metric
        """

        self._target_metric = target_metric

    @property
    def optimize_model_size(self):
        """Gets the optimize_model_size of this GruRequestForm.  # noqa: E501


        :return: The optimize_model_size of this GruRequestForm.  # noqa: E501
        :rtype: bool
        """
        return self._optimize_model_size

    @optimize_model_size.setter
    def optimize_model_size(self, optimize_model_size):
        """Sets the optimize_model_size of this GruRequestForm.


        :param optimize_model_size: The optimize_model_size of this GruRequestForm.  # noqa: E501
        :type: bool
        """

        self._optimize_model_size = optimize_model_size

    @property
    def quantization_levels(self):
        """Gets the quantization_levels of this GruRequestForm.  # noqa: E501


        :return: The quantization_levels of this GruRequestForm.  # noqa: E501
        :rtype: list[QuantizationLevel]
        """
        return self._quantization_levels

    @quantization_levels.setter
    def quantization_levels(self, quantization_levels):
        """Sets the quantization_levels of this GruRequestForm.


        :param quantization_levels: The quantization_levels of this GruRequestForm.  # noqa: E501
        :type: list[QuantizationLevel]
        """

        self._quantization_levels = quantization_levels

    @property
    def optimize_autonac(self):
        """Gets the optimize_autonac of this GruRequestForm.  # noqa: E501


        :return: The optimize_autonac of this GruRequestForm.  # noqa: E501
        :rtype: bool
        """
        return self._optimize_autonac

    @optimize_autonac.setter
    def optimize_autonac(self, optimize_autonac):
        """Sets the optimize_autonac of this GruRequestForm.


        :param optimize_autonac: The optimize_autonac of this GruRequestForm.  # noqa: E501
        :type: bool
        """

        self._optimize_autonac = optimize_autonac

    @property
    def name(self):
        """Gets the name of this GruRequestForm.  # noqa: E501


        :return: The name of this GruRequestForm.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this GruRequestForm.


        :param name: The name of this GruRequestForm.  # noqa: E501
        :type: str
        """

        self._name = name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GruRequestForm):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GruRequestForm):
            return True

        return self.to_dict() != other.to_dict()
